import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

public class beach  extends World
{
    public banner button1player, button2player, counter0, counter1, banner, bannerLives[], bannerScore[];
    public spawnPoint spawnPoint[], spawnPointLobster;
    public boolean menu, bannerAdded, gameOver, gameStarted;
    public int players, leader;
    private int timer, score[], lives[], spawnDelay[], lobsterDelay, noOfLobsters;
    public GreenfootImage footstep, wormImg[];
    
    public beach()
    {    
        super(640, 480, 1); 
        Greenfoot.setSpeed(45);
        setPaintOrder(blackScreen.class, banner.class, spawnPoint.class, animals.class, footstep.class);
        setBackground("images/background.png");
        footstep = new GreenfootImage("images/footstep.png");
        menu = true;
        bannerAdded = false;
        gameOver = false;
        gameStarted = false;
        leader = 2;
        initWormImg();
        lives = new int[2];
        lives[0] = 6;
        lives[1] = 6;
        score = new int[2];
        score[0] = 0;
        score[1] = 0;
        spawnDelay = new int[2];
        spawnDelay[0] = 1;
        spawnDelay[1] = 1;
        button1player = new banner ("1 player", 35);
        button2player = new banner ("2 player", 35);
        addObject (button1player, 320, 260);
        addObject (button2player, 320, 330);
        addObject (new banner (new GreenfootImage ("images/banner.png")), 320, 150);
        addObject (new banner (new GreenfootImage ("images/player0.png")), 100, 295);
        addObject (new banner (new GreenfootImage ("images/player1.png")), 540, 295);
        addObject (new banner (new GreenfootImage ("images/lobster.png")), 320, 420);
    }
    
    public void act ()
    {
        if (menu)
        {
            if (Greenfoot.mousePressed(button1player))
            {
                menu = false;
                players = 1;
                addObject(new blackScreen (), 320, 240);
            }
            if (Greenfoot.mousePressed(button2player))
            {
                menu = false;                
                players = 2;
                addObject(new blackScreen (), 320, 240);
            }
        }
        else if (!gameOver)
        {
            if (gameStarted)
            {
                int i;
                for (i = 0; i < players; i++)
                {
                    if (spawnDelay[i] >= 0)
                    {
                        spawnDelay[i]--;
                    }
                    if (spawnDelay[i] == 0)
                    {
                        addObject (new player(i, 180), spawnPoint[i].getX(), spawnPoint[i].getY());
                        lives[i]--;
                        spawnPoint[i].setLives(lives[i]);
                    }
                }
                if (Greenfoot.getRandomNumber(200 / players) == 0)
                {
                    addObject (new wormInvisible(), Greenfoot.getRandomNumber(600) + 20, Greenfoot.getRandomNumber(440) + 20);
                }
                if (lobsterDelay <= 0)
                {
                    addObject (new lobster(0), spawnPointLobster.getX(), spawnPointLobster.getY());
                    Greenfoot.playSound("sounds/game/quake.wav");
                    lobsterDelay = 1250 * players;
                    noOfLobsters++;
                }
                else
                {
                    if (lobsterDelay % 50 == 0)
                    {
                        if (lobsterDelay <= 150)
                        {
                            Greenfoot.playSound("sounds/game/neon.wav");
                        }
                        spawnPointLobster.setLives(lobsterDelay / 50);
                    }
                    lobsterDelay--;
                }
            }
            if (timer <= 0)
            {
                if (bannerAdded)
                {
                    removeObject(banner);
                    bannerAdded = false;
                    if (banner.getString() == "Ready?   ")
                    {
                        banner = new banner ("Go! ", 75);
                        Greenfoot.playSound("sounds/info/Go.wav");
                        gameStarted = true;
                        timer = 30;
                    }
                }
            }
            else
            {
                if (!bannerAdded && banner != null)
                {
                    addObject(banner, 320, 240);
                    bannerAdded = true;
                }
                timer--;
            }
        }
        else
        {
            timer++;
            if (timer % 20 == 0)
            {
                int i;
                for (i = 0; i < players; i++)
                {
                    if (players == 2)
                    {
                        if (lives[0] == 0 && lives[1] == 0)
                        {
                            if (score[0] > score[1])
                            {
                                Greenfoot.playSound("sounds/info/redwin.wav");
                            }
                            if (score[0] < score[1])
                            {
                                Greenfoot.playSound("sounds/info/greenwin.wav");
                            }
                            if (score[0] == score[1])
                            {
                                
                            }
                            players = -1;
                        }
                    }
                    if (lives[i] > 0)
                    {
                        Greenfoot.playSound("sounds/menu/button.wav");
                        lives[i]--;
                        score[i] += 5;
                        bannerLives[i].newString("" + lives[i]);
                        bannerScore[i].newString("" + score[i]);
                    }
                }
                if (players == 1)
                {
                    if (noOfLobsters <= 0)
                    {
                        if (score[0] >= 100)
                        {
                            Greenfoot.playSound("sounds/info/youwin.wav");
                        }
                        else
                        {
                            Greenfoot.playSound("sounds/info/youloose.wav");
                        }
                        players = -1;
                    }
                    else
                    {
                        Greenfoot.playSound("sounds/menu/button.wav");
                        noOfLobsters--;
                        score[0] += 5;
                        bannerLives[0].newString("" + noOfLobsters);
                        bannerScore[0].newString("" + score[0]);
                    }
                }
            }
        }
    }
    
    public void buildGame()
    {
        noOfLobsters = 0;
        if (players == 1)
        {
            spawnPoint = new spawnPoint[1];
            spawnPoint[0] = new spawnPoint(0);
            addObject(spawnPoint[0], 320, 30);
            counter0 = new banner ("player 1: 0", 20);
            addObject (counter0, 110, 450);
        }
        if (players == 2)
        {
            spawnPoint = new spawnPoint[2];
            spawnPoint[0] = new spawnPoint(0);
            spawnPoint[1] = new spawnPoint(1);
            addObject(spawnPoint[0], 150, 30);
            addObject(spawnPoint[1], 490, 30);
            counter0 = new banner ("player 1: 0", 20);
            counter1 = new banner ("player 2: 0", 20);
            addObject (counter0, 110, 450);
            addObject (counter1, 540, 450);
        }
        int i;
        for (i = 0; i < spawnPoint.length; i++)
        {
            spawnPoint[i].setLives(lives[i]);
        }
        spawnPointLobster = new spawnPoint(2);
        spawnPointLobster.getImage().rotate(180);
        lobsterDelay = 0;
        addObject (spawnPointLobster, 320, 450);
        timer = 100;
        banner = new banner ("Ready?   ", 50);
    }   
    
    public void startGame()
    {
        Greenfoot.playSound("sounds/info/Ready.wav");
    }
    
    public void onEat (player eatingPlayer, int powerUpNo)
    {
        if (eatingPlayer.player == 0)
        {
            counter0.newString("player 1: " + (++score[0]));
        }
        if (eatingPlayer.player == 1)
        {
            counter1.newString("player 1: " + (++score[1]));
        }
        if (players == 2)
        {
            if (score[0] > score[1] && leader != 0)
            {
                leader = 0;
                Greenfoot.playSound("sounds/info/redlead.wav");
            }
            if (score[1] > score[0] && leader != 1)
            {
                leader = 1;
                Greenfoot.playSound("sounds/info/greenlea.wav");
            }
        }
        switch (powerUpNo)
        {
        case 0:
            break;
        case 1:
            
            break;
        case 2:
        
            break;
        case 3:
        
            break;
        case 4:
        
            break;
        }
    }
    
    public GreenfootImage getFootstep ()
    {
        return footstep;
    }
    
    public void respawn (int player)
    {
        if (lives[player] > 0)
        {
            spawnDelay[player] = 100;
        }
        else
        {
            buildResultsDisplay();
        }
    }
    
    public int getLives (int player)
    {
        return lives[player];
    }
    
    public void buildResultsDisplay()
    {
        if (!gameOver)
        {
            if (players == 1)
            {
                GreenfootImage back = new GreenfootImage(400, 100);
                back.setColor(new Color (0, 0, 0, 200));
                back.fill();
                addObject (new banner (back), 320, 240);
                addObject (new banner ("Player 1:", 25, new Color (255, 50, 50)), 200, 225);
                addObject (new banner ("lobsters:", 15, Color.white), 200, 255);
                addObject (new banner ("score:", 15, Color.white), 380, 255);
                bannerScore = new banner[1];
                bannerLives = new banner[1];
                bannerScore[0] = new banner("" + score[0], 15, Color.white);
                bannerLives[0] = new banner("" + noOfLobsters, 15, Color.white);
                addObject (bannerLives[0], 250, 255);
                addObject (bannerScore[0], 420, 255);
                removeObject(counter0);
            }
            if (players == 2)
            {
                GreenfootImage back = new GreenfootImage(400, 200);
                back.setColor(new Color (0, 0, 0, 200));
                back.fill();
                addObject (new banner (back), 320, 240);
                addObject (new banner ("Player 1:", 25, new Color (255, 50, 50)), 200, 170);
                addObject (new banner ("remaining lives:", 15, Color.white), 220, 205);
                addObject (new banner ("score:", 15, Color.white), 380, 205);
                addObject (new banner ("Player 2:", 25, new Color (50, 255, 50)), 200, 260);
                addObject (new banner ("remaining lives:", 15, Color.white), 220, 295);
                addObject (new banner ("score:", 15, Color.white), 380, 295);
                bannerScore = new banner[2];
                bannerLives = new banner[2];
                bannerScore[0] = new banner("" + score[0], 15, Color.white);
                bannerLives[0] = new banner("" + lives[0], 15, Color.white);
                addObject (bannerLives[0], 290, 205);
                addObject (bannerScore[0], 420, 205);
                bannerScore[1] = new banner("" + score[1], 15, Color.white);
                bannerLives[1] = new banner("" + lives[1], 15, Color.white);
                addObject (bannerLives[1], 290, 295);
                addObject (bannerScore[1], 420, 295);
                removeObject(counter0);                
                removeObject(counter1);
            }
            gameOver = true;
        }
    }
    
    private void initWormImg()
    {
        wormImg = new GreenfootImage[10];
        int i;
        for (i = 0; i < 10; i++)
        {
            wormImg[i] = new GreenfootImage("images/worm/frame" + i + ".png");
        }
    }
}
